/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2004-2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	Tv^[QbgˑVAIOW[iCQ7144Apj
 */

/*
 *	{UART1AISP(In system programming)ƃVAʐMŌpD
 *	̂߁A{W[ɂĂUART1VAIOɎgpD
 */

#include	"hw_serial.h"
#include	"sh7144.h"


/*
 *  VAIOW[
 *
 *  ݋֎~ԂŌďoƁD
 */
void
InitHwSerial( void )
{
	/*
	 *  SCI1W[X^oC
	 */
	MSTCR1 &= (UINT16)~0x0002;		/* SCI_1L */

	/*
	 *  M֎~ĊeWX^ݒ
	 */
	SCR1 = (UINT8)0x00;				/* M֎~(SCK[q0,1Ƃ) */

	/*
	 *  NbNgp, ʐM, 8rbgf[^, 1Xgbvrbg,
	 *  peBȂ, }`vZbT, PNbN
	 */
	SMR1 = (UINT8)0x00;

	/*
	 *  {[[gݒiݒl̓wb_QƁj
	 */
	BRR1 = CFG_BRR_SERIAL;

	/*
	 *  M݃xݒiݒ背x̓wb_QƁj
	 *  SSR  RDRF ݗvtOAl0̂ߑ삵ȂD
	 *
	 *  M݂͎gpȂD
	 */
	IPRF = (UINT16) ((IPRF & ~0xF) | CFG_INTLVL_SERIAL_RX1);
	SCR1 |= (UINT8)0x40;

	/*
	 *  IO|[gVA|[gɕύX
	 */
	PACRL2 |= (UINT16)0x0140;		/* PA4 TXD1 o͂, PA3 RXD ͂ */

	/*
	 *  M
	 */
	SCR1 |= (UINT8)0x30;			/* M */

}	/* InitHwSerial	*/


/*
 *  VAIOW[~
 *
 *  ݋֎~ԂŌďoƁD
 *  ʂŏo͂Ă邱ƂۏႷ邱ƁD
 */
void
TermHwSerial( void )
{
	/*
	 *  MёM݋֎~
	 */
	SCR1 = (UINT8)0x0;			/* M֎~(SCK[q0,1Ƃ) */
	SSR1 = (UINT8)0x0;			/* Xe[^X */

	/*
	 *  VA݃xŒቻ
	 */
	IPRF &= (UINT16)(~(0xF << 12));

	/*
	 *  SCI1W[X^oC
	 */
	MSTCR1 &= (UINT16)~0x0002;	/* SCI_1 */

}	/* TermHwSerial	*/


/*
 *  VAIOW[MG[݃T[rX[`
 */
#if defined( OMIT_ISR1_ENTRY )
/* ISR1͖{֐݊֐w肷	*/
#pragma interrupt	ErrHwSerialInt
#endif	/* OMIT_ISR1_ENTRY */
void ErrHwSerialInt( void );
void ErrHwSerialInt( void )
{
	SSR1 &= (UINT8)~0x38;
}


/*
 *  VAIOW[M݃T[rX[`
 */
#if defined( OMIT_ISR1_ENTRY )
/* ISR1͖{֐݊֐w肷	*/
#pragma interrupt	RxHwSerialInt
#endif	/* OMIT_ISR1_ENTRY	*/
void RxHwSerialInt( void );
void RxHwSerialInt( void )
{
	UINT8	rx_data;	/* f[^Mobt@	*/

	/*
	 *  I[oh~̂߂܂Ǎ
	 */
	rx_data = RDR1;

	/*
	 * ݗvNA
	 */
	SSR1 &= ~0x40;

	/*
	 *  M̓R[obNs
	 *  G[̓G[A
	 */
	if( ( SSR1 & (UINT8)0x38 ) == 0x0 ){
		RxSerialInt( rx_data );
	}
	else{
		SSR1 &= (UINT8)~0x38;
	}

}	/* RxHwSerialInt	*/


